<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="批次号" prop="batchno">
        <el-input v-model="queryParams.batchno" placeholder="请输入批次号" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="康复批次名称" label-width="110px" prop="batchName">
        <el-input v-model="queryParams.batchName" placeholder="请输入康复批次名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>

      <el-form-item label="备注" prop="remark">
        <el-input v-model="queryParams.remark" placeholder="请输入备注" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="queryParams.createTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['system:xyrw:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['system:xyrw:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="批次号" align="center" prop="batchno" />
      <el-table-column label="康复批次名称" align="center" prop="batchName" />
      <el-table-column label="批次状态" align="center" prop="batchStatus" >
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.BATCH_STATUS" :value="scope.row.batchStatus"/>
        </template>
        </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['system:xyrw:update']">修改</el-button>
          <el-button size="mini" type="text"  @click="handleNavi(scope.row)"
          v-hasPermi="['system:xyrw:update']">查看</el-button>

          <!-- <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['system:xyrw:delete']">删除</el-button> -->
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />

    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="118px">
        <!-- <el-form-item label="批次号" prop="batchno">
          <el-input v-model="form.batchno" readonly placeholder="请输入批次号" />
        </el-form-item> -->
        <el-form-item label="康复批次名称" prop="batchName">
          <el-input v-model="form.batchName" placeholder="请输入康复批次名称" />
        </el-form-item>
        <!-- <el-form-item label="批次状态" prop="batchStatus">
          <el-radio-group v-model="form.batchStatus">
            <el-radio v-for="dict in this.getDictDatas(DICT_TYPE.BATCH_STATUS)"
                      :key="dict.value" :label="parseInt(dict.value)">{{dict.label}}</el-radio>
          </el-radio-group>   
        </el-form-item> -->
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="confirmtips">确 定</el-button>
        <el-button @click="canceltips">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 提示对话框 -->
    <el-dialog :title="提示" :visible.sync="tipsopen" width="500px" append-to-body>
      <span>新建批次后，旧批次会归入历史数据，</span>
      <span>并且不能再录入和修改数据，请再次确认！</span>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm"  >确 定</el-button>
        <el-button @click="cancel" >取 消</el-button>
      </span>
    </el-dialog>

    <!-- 对话框(修改) -->
    <el-dialog :title="title" :visible.sync="openUpdate" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="118px">
        <!-- <el-form-item label="批次号" prop="batchno">
          <el-input v-model="form.batchno" readonly placeholder="请输入批次号" />
        </el-form-item> -->
        <el-form-item label="康复批次名称" prop="batchName">
          <el-input v-model="form.batchName" placeholder="请输入康复批次名称" />
        </el-form-item>
        <!-- <el-form-item label="批次状态" prop="batchStatus">
          <el-radio-group v-model="form.batchStatus">
            <el-radio v-for="dict in this.getDictDatas(DICT_TYPE.BATCH_STATUS)"
                      :key="dict.value" :label="parseInt(dict.value)">{{dict.label}}</el-radio>
          </el-radio-group>   
        </el-form-item> -->
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { createXyrw, updateXyrw, deleteXyrw, getXyrw, getXyrwPage, exportXyrwExcel } from "@/api/system/xyrw";
import {DICT_TYPE, getDictDatas} from "@/utils/dict";
import {getDate01} from "@/utils/dateUtils";

export default {
  name: "Xyrw",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 批次信息列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      openUpdate: false,
      open: false,
      tipsopen: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        batchno: null,
        batchName: null,
        batchStatus: null,
        remark: null,
        createTime: [],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        batchno: [{ required: true, message: "批次号不能为空", trigger: "blur" }],
        batchName: [{ required: true, message: "康复批次名称不能为空", trigger: "blur" }],
        batchStatus: [{ required: true, message: "批次状态（1进行中 2停止）不能为空", trigger: "blur" }],
      },
      batchDictDatas: getDictDatas(DICT_TYPE.BATCH_STATUS),    
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      getXyrwPage(this.queryParams).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.tipsopen = false;
      this.openUpdate = false;
      this.reset();
    },
    canceltips() {
      this.open = false;
    },
    confirmtips() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        this.open = false;
        this.tipsopen = true;

      });
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        batchno: undefined,
        batchName: undefined,
        batchStatus: undefined,
        remark: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.form.batchno = "XYTJ" + getDate01();
      this.form.batchStatus = 1;
      this.title = "添加批次信息";
    },
    handleNavi(row) {
      const bstatus = row.batchStatus;
      
      if(bstatus == 1){
          this.$router.push({
          path:"/xytj/system/student"
        });
      }else{
        this.$router.push({
          path:"/xytj/system/studentHis"
        });
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getXyrw(id).then(response => {
        this.form = response.data;
        this.openUpdate = true;
        this.title = "修改批次信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateXyrw(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.openUpdate = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createXyrw(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.tipsopen =false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除批次信息编号为"' + id + '"的数据项?').then(function() {
          return deleteXyrw(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.$modal.confirm('是否确认导出所有批次信息数据项?').then(() => {
          this.exportLoading = true;
          return exportXyrwExcel(params);
        }).then(response => {
          this.$download.excel(response, '批次信息.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
